"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.decodeSubquery = exports.mongooseSubqueryPlugin = void 0;
const utils_1 = require("./utils");
Object.defineProperty(exports, "decodeSubquery", { enumerable: true, get: function () { return utils_1.decodeSubquery; } });
const defaultOptions = {
    bindHooks: [
        "count",
        "countDocuments",
        "deleteMany",
        "deleteOne",
        "estimatedDocumentCount",
        "find",
        "findOne",
        "findOneAndDelete",
        "findOneAndRemove",
        "findOneAndReplace",
        "findOneAndUpdate",
        "remove",
        "replaceOne",
        "update",
        "updateOne",
        "updateMany",
    ],
};
function mongooseSubqueryPlugin(schema, options = {}) {
    options = Object.assign({}, defaultOptions, options);
    // @ts-ignore
    schema.query.decodeSubquery = function () {
        return (0, utils_1.decodeSubquery)(this, options);
    };
    function run(next) {
        if (typeof this.decodeSubquery === "function") {
            this.decodeSubquery().then(() => next());
        }
        else {
            next();
        }
    }
    options.bindHooks.forEach((h) => schema.pre(h, run));
}
exports.mongooseSubqueryPlugin = mongooseSubqueryPlugin;
exports.default = mongooseSubqueryPlugin;
//# sourceMappingURL=index.js.map